﻿using CommonBehaviors.Actions;
using Styx.TreeSharp;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Styx;
using Styx.WoWInternals.WoWObjects;
using Styx.CommonBot;
#region [Method] - Class Redundancy
using HkM = Monkee.Core.Managers.HotkeyManager;
using SB = Monkee.Core.Helpers.SpellBook;
using TM = Monkee.Core.Managers.TalentManager;
using U = Monkee.Core.Unit;
using S = Monkee.Core.Spell;
using L = Monkee.Core.Utilities.Log;
using OV = Monkee.Interface.GUI.frmOverlay;
using Styx.WoWInternals;
#endregion  

namespace Monkee.Rotation
{
    class Rotation
    {
        protected const int GCD = 1500;
        protected static LocalPlayer Me { get { return StyxWoW.Me; } }
        protected static WoWSpec MySpec { get { return Me.Specialization; } }
        protected static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        protected static WoWUnit Focused { get { return StyxWoW.Me.FocusedUnit; } }



        #region [Method] - Combat Buffing Routine
        public static async Task<bool> CombatBuffCoRoutine() {
            if (HkM.manualOn)
                return true;
            if (OV.isShown())
                OV.updateRange(currentTarget);
            

            if (Main.Settings.minHPtoUseHTorHS != 0 && Me.HealthPercent < Main.Settings.minHPtoUseHTorHS)
            {
                WoWItem iHt = S.FindFirstUsableItemByItemId(109223);
                if (iHt != null)
                    iHt.Use();
                else
                {
                    WoWItem iHs = S.FindFirstUsableItemByItemId(5512);
                    if (iHs != null)
                        iHs.Use();
                }
            }
            // Pause while casting, dead, mounted etc
            if (StyxWoW.Me.IsCasting || currentTarget == null || SpellManager.GlobalCooldown || !StyxWoW.Me.IsAlive || HkM.manualOn || currentTarget.IsFriendly || currentTarget.IsDead)
                return true;

            if (!Me.IsAutoAttacking)
            {
                Me.ToggleAttack();
                L.combatLog("Auto attack on {0}", currentTarget.Name);
                return true;
            }

            if (Me.Specialization == WoWSpec.MonkWindwalker)
                await Windwalker.CombatCoRoutine();
            else if (Me.Specialization == WoWSpec.MonkBrewmaster)
                await Brewmaster.CombatCoRoutine();
            return false;
        }

       
        #endregion

        #region [Method] - Precombat Buffing Routine
        public static async Task<bool> PreCombatCoRoutine()
        {
            if (Me.Specialization == WoWSpec.MonkMistweaver)
            {
                L.combatLog("Current spec {0} is not supported yet. Do nothing.", Me.Specialization);
                return true;
            }
            U.toggleTimer();
            // Pause while casting, dead, mounted etc
            if (Me.IsChanneling || Me.CanLoot || U.IsEatingOrDrinking() || SpellManager.GlobalCooldown  || !StyxWoW.Me.IsAlive || StyxWoW.Me.Mounted || HkM.manualOn  || StyxWoW.Me.IsOnTransport)
                return true;

            //stack Chi while not in Combat
            if (HkM.preBuff && !Me.Combat && await S.spellCast(SB.spellExpelHarm, false))
                return true;
            if (HkM.preBuff && U.needToBuffMe() && currentTarget == null && await S.spellCast(SB.spellLegacyOfTheWhiteTiger, false))
            {
                return true;
            }

            // Return false at the end of the buffing logic
            // If we don't return false, then it'll prevent moving further down the 'global' tree. I.e. it won't call CombatBehavior etc.
            return false;
        }
                
        #endregion

        
    }
}
